/*
 * Name: MRP Row Background Color
 * Developer: Vinyl
 * Date: 06/12/2020
 */
define(function () {
    var setRowColor = function($rowElement, context, value, originalColor) {
        if (value === "" || value === null) {
            $rowElement.css("background-color", originalColor);
        } else {
            $rowElement.css("background-color", value);
        }
    }

    var install = function (holderElement, context) {
        // This gets the cell the widget is attached to
        var cell = context.getCell();

        // Access the DOM after the view.html has been created
        var $rowElement = $(holderElement).closest(".vinyl-controls-datagrid-row");        
        var originalColor = $rowElement.css("background-color");
        
        // When the cell changes, get the new value
        cell.setChangeCallback('value', function (value) {
            setRowColor($rowElement, context, value, originalColor);
        });

        // Set it once when installing.
        setRowColor($rowElement, context, cell.value, originalColor);
    };

    var uninstall = function(holderElement, context) {
        // Nothing to do.
    };

    return {
        callbacks: {
            events: {
                // adding and removing
                install: install,
                uninstall: uninstall
            }
        }
    };
});